function love.load()
	require("maths")
	garm = require("garm")

	lgr = love.graphics
	lmo = love.mouse
	
	x1, y1 = 0, 0
	x2, y2 = 0, 0
	x3, y3, x3v, y3v = 0, 0, 0, 0
	c1 = {r = 255, g = 127, b = 0}
	c2 = {r = 127, g = 255, b = 0}
	c3 = {r = 0, g = 127, b = 255}
	a1, a2, a3, a4 = true, true, true, true
	
	math.randomseed(os.time())
	lgr.setBackgroundColor(255, 255, 255)
	
	canvas = lgr.newCanvas(800, 800, "normal", 16)
end

function love.draw()
	if a3 then
		lgr.setColor(c3.r, c3.g, c3.b)
		lgr.circle("fill", x3, y3, 20, 50)
		lgr.setCanvas(canvas)
		lgr.circle("fill", x3, y3, 20, 50)
		lgr.setCanvas()
	end
	if a2 then
		lgr.setColor(c2.r, c2.g, c2.b)
		lgr.circle("fill", x2, y2, 20, 50)
		lgr.setCanvas(canvas)
		lgr.circle("fill", x2, y2, 20, 50)
		lgr.setCanvas()
	end
	if a1 then
		lgr.setColor(c1.r, c1.g, c1.b)
		lgr.circle("fill", x1, y1, 20, 50)
		lgr.setCanvas(canvas)
		lgr.circle("fill", x1, y1, 20, 50)
		lgr.setCanvas()
	end
	if a4 then
		lgr.setColor(255, 255, 255)
		lgr.setBlendMode("premultiplied")
		lgr.draw(canvas, 0, 0)
		lgr.setBlendMode("alpha")
	end
end

function love.update(dt)
	local mx, my = lmo.getPosition()
	
	-- calculating for 1
	local f = 0.0005
	x1 = (x1 - mx)*(f^dt) + mx
	y1 = (y1 - my)*(f^dt) + my
	
	-- calculating for 2
	local dir = math.angle(x2, y2, mx, my)
	local dis = math.dist(x2, y2, mx, my)
	x2 = x2 + math.cos(dir)*math.min(500*dt, dis)
	y2 = y2 + math.sin(dir)*math.min(500*dt, dis)
	
	-- calculating for 3
	-- direction to target
	local dir = math.angle(x3, y3, mx, my)
	local dis = math.dist(x3, y3, mx, my)
	-- accelerate towards target
	x3v = math.cos(dir)*1000*dt + x3v
	y3v = math.sin(dir)*1000*dt + y3v
	-- drag/friction
	local dirv = math.angle(0, 0, x3v, y3v)
	local disv = math.dist(0, 0, x3v, y3v)
	disv = disv*(0.2^dt)
	x3v = math.cos(dirv)*disv
	y3v = math.sin(dirv)*disv
	-- calculate new position
	x3 = x3 + x3v*dt
	y3 = y3 + y3v*dt
end

function love.keypressed(key)
	if key == "1" then
		a1 = not a1
	end
	if key == "2" then
		a2 = not a2
	end
	if key == "3" then
		a3 = not a3
	end
	if key == "4" then
		a4 = not a4
		canvas:clear()
	end
	if key == "c" then
		canvas:clear()
	end
end

--[[--
function love.draw() end
function love.errhand(msg) end
function love.focus(f) end
function love.gamepadaxis(joystick, axis, value) end
function love.gamepadpressed(joystick, button) end
function love.gamepadreleased(joystick, button) end
function love.joystickadded(joystick) end
function love.joystickaxis(joystick, axis, value) end
function love.joystickhat(joystick, hat, direction) end
function love.joystickpressed(joystick, button) end
function love.joystickreleased(joystick, button) end
function love.joystickremoved(joystick) end
function love.keypressed(key, isrepeat) end
function love.keyreleased(key) end
function love.load(arg) end
function love.mousefocus(f) end
function love.mousemoved(x, y, dx, dy) end
function love.mousepressed(x, y, button) end
function love.mousereleased(x, y, button) end
function love.quit() end
function love.resize(w, h) end
function love.run() end
function love.textinput(text) end
function love.threaderror(thread, errorstr) end
function love.update(dt) end
function love.visible(v) end
--]]--